var ajax = {};
ajax.getAsDataUrl = function (url, callback) {
  var xhr = new XMLHttpRequest();
  xhr.timeout = 5000;
  xhr.onload = function () {
    //console.log("xhr.onload, url=" + url + ", status=" + xhr.status + ", length=" + xhr.response.length)
    var reader = new FileReader();
    reader.onloadend = function () {
      runningRequests--;
      callback(reader.result);
      triggerDownloads();
    }
    reader.onerror = function (event) {
      //console.log("Failed to read file for url " + url + ", error: " + reader.error);
      runningRequests--;
      triggerDownloads()
    };
    reader.readAsDataURL(xhr.response);
  };
  xhr.open('GET', url);
  xhr.responseType = 'blob';
  xhr.send();
}

var downloadImage = function (image) {
  //console.log("downloadImage " + image.dataset.src);
  runningRequests++;
  ajax.getAsDataUrl(image.dataset.src, function (dataUrl) {
    image.src = dataUrl;
  });
}

var triggerDownloads = function () {
  //console.log("triggerDownloads, runningRequests=" + runningRequests);
  while (runningRequests < maxConcurrency && allImages.length > 0) {
    downloadImage(allImages.shift());
  }
}

var maxConcurrency = 4;
var runningRequests = 0;
var allImages = []; // All the image elements

var listenForImagesLoaded = function(imageElements) {
  var totalImages = imageElements.length;
  if (totalImages === 0) {
    window.location.href = "event://images-loaded";
    return;
  }
  var loadedImages = 0;
  [].forEach.call(imageElements, function(imageElement) {
    imageElement.addEventListener('load', onImageLoadOrError, false);
    imageElement.addEventListener('error', onImageLoadOrError, false);
  });
  function onImageLoadOrError(event) {
    loadedImages++;
    //console.log("incrementCounter: loaded=" + loadedImages + "(" + totalImages + "), eventType=" + event.type + ", src=" + event.target.src);
    if ( loadedImages === totalImages ) {
      window.location.href = "event://images-loaded";
    }
  }
}

window.addEventListener('load', (event) => {
  //console.log(document.querySelector('meta[name="concurrency"]'));
  concurrencyInMeta = parseInt(document.querySelector('meta[name="concurrency"]').content);
  if (!isNaN(concurrencyInMeta)) {
    maxConcurrency = concurrencyInMeta;
    //console.log("Concurrent image loading threads is set to " + maxConcurrency);
  }
  document.querySelectorAll('.photo').forEach(function (image) {
    allImages.push(image)
  });
  listenForImagesLoaded(allImages);
  triggerDownloads();
});
